#!/usr/bin/python

import os
import shutil
import subprocess
import time
import signal
import re
import getopt, sys
import glob
from optparse import OptionParser
from time import localtime, strftime
import string
import datetime
import myutils
import itertools
#---------------------------------------------------------------------------------------------------------------------------------
GMUTANTS='mutants'
GOUTPUTS='outputs'
GINPUTS='inputs'
TIMEOUT_LIMIT=0.05 # in seconds
#---------------------------------------------------------------------------------------------------------------------------------
def main():
	curdir = os.getcwd()
	mutants=glob.glob('%s/%s/mutant*.c'%(curdir,GMUTANTS))
	mutants.sort()
	mid = 0
	lines = myutils.getFileLines('list')
	inputs=[]
	outputs=[]
	for line in lines:
		parts = line.split('>')
		assert(len(parts)==2)
		p1 = parts[0].strip()
		p2 = parts[1].strip()
		inputs.append(p1)
		outputs.append(p2)
		
	for mutant in mutants:
		muname = os.path.basename(mutant)
		tmp = muname.split('_')
		muname = tmp[0]
	
		myutils.exec_cmd('rm -rf a.out')
		myutils.exec_cmd('gcc -O3 %s -o a.out -I source.alt/source.orig/'%(mutant))
		if os.path.exists('./a.out'):
			myutils.exec_cmd('mkdir %s/%s'%(GOUTPUTS,muname))
			# run it
			numinputs=len(inputs)
			for j in range(numinputs):
				outfile='%s/%s/%s'%(GOUTPUTS, muname, outputs[j])
				p = subprocess.Popen('./a.out %s/%s > %s'%(GINPUTS,inputs[j], outfile), shell=True)
				mtime = time.time()
				while p.poll() == None:
					time.sleep(0.005)
					fs = 0
					if os.path.exists(outfile):
						fs = os.path.getsize(outfile)
					if( time.time()-mtime > TIMEOUT_LIMIT or fs > 5000):
						p.kill()
						break
			os.chdir('%s'%(GOUTPUTS))
			myutils.exec_cmd('tar czf %s.tar.gz %s'%(muname,muname))
			myutils.exec_cmd('rm -rf %s'%(muname))
			os.chdir('%s'%(curdir))			
#---------------------------------------------------------------------------------------------------------------------------------
if __name__ == "__main__":
    main()


