#*
# * gcov2linecov.py: read gcov files and generate line coverage bit vector.
# *
# * Copyright (C) 2011-2013 Oregon State University.
# *
# * Created by Chaoqiang Zhang <zhangch@eecs.oregonstate.edu>
# * 
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
#
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# * 
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# *
import commands
import string
import subprocess
import myutils
import os
import sys
import glob

maxlen=0
#--------------------------------------------------------
def getLineCoverage(filename):
    s=''
    f = open(filename)
    lines = f.readlines()
    f.close()
    
    for line in lines:
        newline=line.strip()
        lineno=newline.split(':')[1].strip()
        lineno=int(lineno)
        if lineno >=1:
          if newline[0] != '-' and newline[0] != '#':
            s+='1,'
          else:
            s+='0,'
    global maxlen        
    if maxlen==0:
      maxlen=len(s)
    else:
      assert(maxlen==len(s))
    return s
#--------------------------------------------------------
progname=sys.argv[1]
targetdir=sys.argv[2]
files=glob.glob('%s/%s.c.gcov.*'%(targetdir,progname))
numfiles=len(files)
for i in range(1,numfiles+1):
  f='%s/%s.c.gcov.%d'%(targetdir,progname,i)
  cov=getLineCoverage(f)
  if cov.find('1')>=0:
    myutils.appendline2file('%s/line.cov'%(targetdir),cov)

