#*
# * collectcov.sh: coverage collection for line/branch/path/acyclicpath/predicate coverage.
# *
# * Copyright (C) 2011-2013 Oregon State University.
# *
# * Created by Chaoqiang Zhang <zhangch@eecs.oregonstate.edu>
# * 
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
#
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# * 
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# *

toolsdir=../../../tools/coveragehooks/
sourcedir=../source

prog=replace

rm coverage -rf
mkdir coverage
rm *.cov pathcount acyclicpathcount -rf

# line/statement coverage first
cd $sourcedir
bash instr.sh

rm line.cov
gcc -O0 --coverage -o $prog.exe $sourcedir/$prog.c
bash ../scripts/runallgcov.sh
cd ../scripts
python gcov2linecov.py $prog $sourcedir
cp $sourcedir/line.cov ./

cp ${sourcedir}/blockcount ${sourcedir}/branchcount ${sourcedir}/blockpredcount ${sourcedir}/stmtpredcount ./
types=( block branch path acyclicpath pred predStmt )
for type in "${types[@]}"
do 
    cd $sourcedir
    rm $prog.exe
    if  [ "$type" = "none" ]; then
        gcc -O0 -o $prog.exe $prog.c
    else
        gcc -O0 -o $prog.exe $prog.$type.cil.c $toolsdir/covhooks.cpp -lstdc++ -ldl -lpthread
    fi
    cd -
    (time bash runall.sh) 1> /dev/null
done
mv *.cov coverage
