#!/usr/bin/python
#*
# * myutils.py: python utilities for coverage data collection.
# *
# * Copyright (C) 2011-2013 Oregon State University.
# *
# * Created by Chaoqiang Zhang <zhangch@eecs.oregonstate.edu>
# * 
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
#
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# * 
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# *
import os
import shutil
import subprocess
import time
import signal
import re
import getopt, sys
import glob
from optparse import OptionParser
from time import localtime, strftime
import string
import datetime

#---------------------------------------------------------------------------------------------------------------------------------
class Timer:
    tstart = 0
    tend = 0
    def start(self):
        self.tstart = time.time()
    def end(self):
        self.tend = time.time()
    def elapsed(self):
        return (time.time() - self.tstart)

#---------------------------------------------------------------------------------------------------------------------------------
def ensuredir(dir):
    if not os.path.exists(dir):
        os.makedirs(dir)
#---------------------------------------------------------------------------------------------------------------------------------
def countFileLines(filename) :
    count_lines = 0
    if not os.path.exists(filename) :
        return 0
    else :
        file = open(filename)
        for line in file.readlines():
            if len(line) > 1:
                count_lines = count_lines+1
        file.close()
        return count_lines
#---------------------------------------------------------------------------------------------------------------------------------
def getFileLines(filename) :
    lines = []
    if os.path.exists(filename):
        file = open(filename)
        lines=file.readlines()
        file.close()
    return lines
#---------------------------------------------------------------------------------------------------------------------------------
def readSingleLine(filename) :
    res = ''
    if os.path.exists(filename):
        file = open(filename)
        for line in file.readlines():
            res = line.replace('\n','')
            break
        file.close()
    return res
#---------------------------------------------------------------------------------------------------------------------------------
def readArray(filename):
    str = readSingleLine(filename)
    arr = str.split(',')
    res=[]
    for a in arr:
        if a != '':
            res.append( int(a))
    return res
#---------------------------------------------------------------------------------------------------------------------------------
def writeArray(filename, arr):
    s = ''
    for a in arr:
        s = s+str(a)+','
    writeline2file(filename, s)
#---------------------------------------------------------------------------------------------------------------------------------
def appendArray(filename, arr):
    s = ''
    for a in arr:
        s = s+str(a)+','
    appendline2file(filename, s)
#---------------------------------------------------------------------------------------------------------------------------------
def appendArrayNoNewline(filename, arr):
    s = ''
    for a in arr:
        s = s+str(a)+','
    appendline2filenonewline(filename, s)
#---------------------------------------------------------------------------------------------------------------------------------        
def appendline2filenonewline(filename, content) :
    file = open(filename, 'a+')
    file.write(content)
    file.close()
#---------------------------------------------------------------------------------------------------------------------------------        
def appendline2file(filename, content) :
    file = open(filename, 'a+')
    file.write(content+"\n")
    file.close()
#---------------------------------------------------------------------------------------------------------------------------------        
def writeline2file(filename, content) :
    file = open(filename, 'w')
    file.write(content+"\n")
    file.close()
#---------------------------------------------------------------------------------------------------------------------------------
def appendlines2file(filename, content) :
    file = open(filename, 'a+')
    for str in content:
        file.write(str+"\n")
    file.close()
#---------------------------------------------------------------------------------------------------------------------------------
def appendlines2filenonewline(filename, content) :
    file = open(filename, 'a+')
    for str in content:
        file.write(str)
    file.close()
#---------------------------------------------------------------------------------------------------------------------------------        
def rotatefile(filename):
    file = open(filename)
    lines = file.readlines()
    for i in range( len(lines[0]) ):
       str = ''
       for line in lines:
           if len(line) > 2:
               str = str + line[i]
       appendline2file('output', str)

    file.close()
    exec_cmd('cp -f %s %s'%('output', filename))
    rmfiles( ['output'] )

#---------------------------------------------------------------------------------------------------------------------------------
def rmfiles( files ):
    for file in files:
        exec_cmd( 'rm -rf %s'%(file))

#---------------------------------------------------------------------------------------------------------------------------------
def exec_cmd( cmd ):
    print( cmd)
    p = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT)
    sts = os.waitpid(p.pid, 0)[1]
    return p
#---------------------------------------------------------------------------------------------------------------------------------

