#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <vector>
#include <list>
#include <string>
#include <stack>
#include <map>
#include <algorithm>
// predefine consts for all coverage
int cblocks = 177;
int cbranches = 168;
int cpredicates = 1073;
int cstmtpredicates = 2043;

const char* blockfilename = "block.bin";
const char* branchfilename = "branch.bin";
const char* pathfilename = "path.bin";
const char* predfilename = "pred.bin";
const char* stmtpredfilename = "stmtpred.bin";

/////////////////////////////////////////
int currtype = -1;
FILE* currfile = NULL;
unsigned char* currbuffer = NULL;
//int currbuffersize = -1;

//char* filename = "pred.bin";
//int filesize = 186850;
extern "C" void open_trace_db( char* dbname,  char* blockmeta,  char* branchmeta,  char* pathmeta,  char* predmeta, char* stmtpredmeta) {
	/*
	int status = -1;
	currbuffer = (unsigned char*)malloc(filesize);
	memset(currbuffer, 0, filesize);
	currfile = fopen(filename, "w+");
	if( currfile ) {
		status = fread(currbuffer, filesize, 1, currfile);
		if( status == filesize) {
			
		}
		else {
			//exit(0);
		}
	}, "
	else {
		assert(0);
	}
	*/
}

extern "C" void close_trace_db() {
	//fwrite(currbuffer, filesize, 1, currfile);
	//fclose(currfile);
	//free(currbuffer);
}

extern "C" void begin_trace_session(char* type, int addnew) {
	if( strcmp(type, "block") == 0) {
		currtype = 0;
		currbuffer = (unsigned char*)malloc(cblocks);
		memset(currbuffer, 0, cblocks);
		currfile=fopen(blockfilename, "w+");
		if(currfile) {
			fread(currbuffer, cblocks, 1, currfile);
		}
		else {
			assert(0);
		}
	}
	else if( strcmp(type, "branch") == 0) {
		currtype = 1;
		currbuffer = (unsigned char*)malloc(cbranches);
		memset(currbuffer, 0, cbranches);
		currfile=fopen(branchfilename, "w+");
		if(currfile) {
			fread(currbuffer, cbranches, 1, currfile);
		}
		else {
			assert(0);
		}
	}
	else if( strcmp(type, "path") == 0) {
		currtype = 2;
		currfile=fopen(pathfilename, "w+");
	}
	else if( strcmp(type, "pred") == 0) {
		currtype = 3;
		currbuffer = (unsigned char*)malloc(cpredicates);
		memset(currbuffer, 0, cpredicates);
		currfile=fopen(predfilename, "w+");
		if(currfile) {
			fread(currbuffer, cpredicates, 1, currfile);
		}
		else {
			assert(0);
		}
	}
	else if( strcmp(type, "stmtpred") ==0) {
		currtype = 4;
		currbuffer = (unsigned char*)malloc(cstmtpredicates);
		memset(currbuffer, 0, cstmtpredicates);
		currfile=fopen(stmtpredfilename, "w+");
		if(currfile) {
			fread(currbuffer, cstmtpredicates, 1, currfile);
		}
		else {
			assert(0);
		}
	}
}


extern "C" void add_block_vector(int bid, char* fname, char* mname, int gbid, int flag) {
	currbuffer[bid] = 1;
}
extern "C" void add_branch_vector(int bid, char* fname, char* mname, int gbid, int flag) {
	currbuffer[bid] = 1;
}
typedef std::vector<int> ti_path;
typedef std::vector<ti_path> ti_paths ;

std::stack<ti_path, std::list<ti_path> > currpaths;
std::string currfunc;
typedef std::map<std::string, ti_paths> func_paths_map;
typedef std::map<std::string, ti_paths>::const_iterator const_func_paths_map_iterator;
typedef std::map<std::string, ti_paths>::iterator func_paths_map_iterator;
typedef std::vector<ti_path>::const_iterator const_paths_iterator;
func_paths_map m_func_paths_map; 

extern "C" void add_func_path_entry(const std::string& func_name, const ti_path& newpath) {
    func_paths_map_iterator itr = m_func_paths_map.find( func_name);
    if( itr != m_func_paths_map.end() ) {
        ti_paths& paths4func = itr->second;
        const_paths_iterator piter = std::find(paths4func.begin(), paths4func.end(), newpath);
        if( piter != paths4func.end() ) {
        }
        else {
            paths4func.push_back( newpath );
        }
    }
    else {
        ti_paths tmppaths;
        tmppaths.push_back( newpath );
        m_func_paths_map.insert( std::make_pair( func_name, tmppaths ) );
    }    
}

extern "C" void add_cfgnode_vector(int bid, char* fname, char* mname, int sid, int stat) {
	/* start new function path */
    if( stat == -1 || stat == 2 ) {
		ti_path newpath;
        currpaths.push(newpath);
        currfunc = mname;
    }
    /* intermediate nodes */
    if( stat == -1 || stat == 0 || stat == 1 || stat == 2 ) {    
		assert( !currpaths.empty() );
        ti_path& currpath = currpaths.top();        
		currpath.push_back(sid);
    }
    /* function exit */
    if( stat == 1 || stat == 2) {
        assert( !currpaths.empty() );
        ti_path& currpath = currpaths.top();
        add_func_path_entry(currfunc, currpath);
        currpaths.pop();
    } 
}
//
extern "C" void begin_pred_values(int id, char* filename, char* funcname, int blkid, int extra) {
}
extern "C" void add_pred_value(int id, char* predicate, int predvalue) {
	currbuffer[id] |= ( (predvalue!=0)? 2 : 1 );
}

extern "C" void end_trace_session(char* type) {
	if( strcmp(type, "block") == 0) {
		fwrite(currbuffer, cblocks, 1, currfile);
		fclose(currfile);
		free(currbuffer);
		currbuffer = NULL;
	}
	if( strcmp(type, "branch") == 0) {
		fwrite(currbuffer, cbranches, 1, currfile);
		fclose(currfile);
		free(currbuffer);
		currbuffer = NULL;
	}
	if( strcmp(type, "path") == 0) {
		int tmp = m_func_paths_map.size();
		fwrite(&tmp, sizeof(int), 1, currfile);
		const_func_paths_map_iterator itr = m_func_paths_map.begin();
		for(; itr != m_func_paths_map.end(); itr++ ) {
			const char* name = itr->first.c_str();
			fwrite(name, strlen(name)+1, 1, currfile);
			//out.write_string(itr->first);
			tmp = itr->second.size();
			fwrite(&tmp, sizeof(int), 1, currfile);
			//out.write_uint32( itr->second.size());
			const ti_paths& paths = itr->second;
			ti_paths::const_iterator pathsitr = paths.begin();
			for( ; pathsitr != paths.end(); pathsitr++ ) {
				tmp = itr->second.size();
				fwrite(&tmp, sizeof(int), 1, currfile);
				//out.write_uint32(pathsitr->size());
				const ti_path& path = *pathsitr;
				ti_path::const_iterator pathitr = path.begin();
				for( ; pathitr != path.end(); pathitr++ ) {
					tmp = *pathitr;
					fwrite(&tmp, sizeof(int), 1, currfile);
					//out.write_uint32(*pathitr);
				}
			}        
		}
		fclose(currfile);
	}
	if( strcmp(type, "pred") == 0) {
		fwrite(currbuffer, cpredicates, 1, currfile);
		fclose(currfile);
		free(currbuffer);
		currbuffer = NULL;
	}
	if( strcmp(type, "stmtpred") == 0) {
		fwrite(currbuffer, cstmtpredicates, 1, currfile);
		fclose(currfile);
		free(currbuffer);
		currbuffer = NULL;
	}
}
