#!/bin/bash


taskid=`echo $1-1|bc`

remotedir=/nfs/guille/groce/users/zhangch/llvm/klee/subjects/replace
srcdir=/scratch/eecs-share/zhangch/
workdir=/scratch/eecs-share/zhangch/replace-${taskid}-${BASHPID}
if [ -e $workdir ]; then
	rm $workdir -rf
fi
mkdir $workdir

cp $srcdir/replace $workdir/ -rf
cd $workdir/replace

readarray cmdoptions < allcmdoptions
readarray chosedindices < chosedindices
d=${chosedindices[$taskid]}
i1=`echo $d*3 | bc`
i2=`echo $d*3+1 | bc`
i3=`echo $d*3+2 | bc`

cmdoption=""${cmdoptions[$i1]}" "${cmdoptions[$i2]}" "inputs/${cmdoptions[$i3]}""

echo $cmdoption

klee -max-memory-inhibit=false --only-output-states-covering-new --source-filter=replace.c --output-coveredbbs --zest --use-symbex=1 --symbex-for=10 --search=dfs --zest-search-heuristic=br --watchdog --max-time=1200 --seed-time=300 --optimize --max-cex-size=0 --zest-continue-after-error=true --output-source=false --no-std-out --output-level=all --use-cex-cache=false ---dump-states-on-halt=false -use-forked-stp --max-stp-time=50 --posix-runtime --libc=uclibc replace.bc ${cmdoption} > /dev/null


if [ -e klee-out-0 ]; then
  mkdir -p $remotedir/runres/klee$taskid
  rm klee-out-0/*.ktest
  rm klee-out-0/*.ts
  rm klee-out-0/*.stat*
  rm klee-out-0/*.istat*
  rm klee-out-0/*.path
  cp klee-out-0 $remotedir/runres/klee$taskid/ -rf
fi 

cd /scratch/
rm $workdir -rf


