#!/usr/bin/python

import os
import shutil
import subprocess
import time
import signal
import re
import getopt, sys
import glob
from optparse import OptionParser
from time import localtime, strftime
import string
import datetime
import myutils
import itertools
#---------------------------------------------------------------------------------------------------------------------------------
GMUTANTS='../mutants'
GOUTPUTS='outputs'
GINPUTS='inputs'
TIMEOUT_LIMIT=0.1# in seconds
#---------------------------------------------------------------------------------------------------------------------------------
def getAllTestCasesInfo():
	testcases=[]
	tmplines = myutils.getFileLines('runall_rm.sh')	
	for tmpline in tmplines:
		if tmpline.find('tot_info.exe') > -1:
			t1 = tmpline.rfind(' > ')
			if t1 > -1:
				tmpline=tmpline[0:t1]
			tmpline = tmpline.replace('../source/tot_info.exe ', '')
			tmpline = tmpline.strip(' ')
			tmpline = tmpline.replace('  ',' ')
			tmpline = tmpline.replace('  ',' ')
			if '  < ../inputs/universe/' in tmpline:
				tmpline = tmpline.replace('  < ../inputs/universe/', '< ')
			if ' < ../inputs/universe/' in tmpline:
				tmpline = tmpline.replace(' < ../inputs/universe/', '< ')
			if '< ../inputs/universe/' in tmpline:
				tmpline = tmpline.replace('< ../inputs/universe/', '< ')
			testcases.append(tmpline)
			print(tmpline)
	print("-------------------------")
	return testcases
#---------------------------------------------------------------------------------------------------------------------------------
def getAllSuiteFiles():
	sfiles = []
	sfiles=glob.glob('../testplans.alt/ducov/suite*')
	sfiles.sort()
	return sfiles
#---------------------------------------------------------------------------------------------------------------------------------
def getTestCasesInTestSuite(tsfile):
	testcases=[]
	lines = myutils.getFileLines(tsfile)
	for line in lines:
		line = line.strip(' ')
		line = line.replace('  ',' ')
		line = line.replace('  ',' ')
		line = line.replace('< input/', '< ')
		testcases.append(line)
	return testcases
#---------------------------------------------------------------------------------------------------------------------------------
def getIdxOfTestCase(testcase, alltestcases):
	idx = -1
	testcase=testcase.rstrip('\n')
	print(testcase)
	if testcase in alltestcases:
		idx = alltestcases.index(testcase)
	return idx
#---------------------------------------------------------------------------------------------------------------------------------
def mainwork():
	sfiles = getAllSuiteFiles()
	#print(sfiles)
	testcases = getAllTestCasesInfo()
	#print(testcases)
	for sfile in sfiles:
		resstr = ''
		alltsintestsuite = getTestCasesInTestSuite(sfile)
		for testcase in alltsintestsuite:
			idx = getIdxOfTestCase(testcase, testcases)
			if idx != -1:
				resstr = resstr+str(idx)+','
		myutils.appendline2file('testsuites',resstr)

#---------------------------------------------------------------------------------------------------------------------------------
def main():
	mainwork()
#---------------------------------------------------------------------------------------------------------------------------------
if __name__ == "__main__":
    main()


